﻿// Copyright (c) 2024 Jordon Brooks
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0

// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

// Use a preprocessor definition to switch between export and import declarations
#ifdef _WIN32
    #ifdef HARMONYLINK_STATIC
        #define HARMONYLINK_API
    #else
        #ifdef HARMONYLINK_SHARED
            #define HARMONYLINK_API __declspec(dllexport)
        #else
            #define HARMONYLINK_API __declspec(dllimport)
        #endif
    #endif
#else
    #define HARMONYLINK_API
#endif
