// Copyright (c) 2024 Jordon Brooks
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0

// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <stdio.h>
#include <stdbool.h>

#include "Core.h"

#ifdef __cplusplus
namespace LibHarmonyLink {
extern "C" {
#endif

typedef struct {
    char* name;
    char* version;
    unsigned int id;
    char* version_id;
    char* version_codename;
    char* pretty_name;
    char* variant_id;
} FOSVerInfo;

// Initialize FCPUInfo
FOSVerInfo* FOSVerInfo_Init(char* name, char* version, unsigned int id, char* version_id, char* version_codename, char* pretty_name, char* variant_id);

// Print FlagsInfo
HARMONYLINK_API void HL_FOSVerInfo_Print(const FOSVerInfo* OSVerInfo);

// Free FCPUInfo
HARMONYLINK_API void HL_FOSVerInfo_Free(FOSVerInfo* OSVerInfo);

#ifdef __cplusplus
}
}
#endif
